<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Tasl 520 - Comment List</title>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<style>

  .div-title {
    font-size: 40px;
    height: 100px;
    color: rgb(0, 195, 255);
    text-align: center;
    margin-top: 50px;
  }

  .div-table {
    margin-top: 40px;
    margin-bottom: 50px;
    padding-left: 150px;
    padding-right: 150px;
  }

   .div-head {
    text-align: center;
  }
</style>

<body>

  <div class="container-fluid">
    <div  class="div-title"><b>LIST OF COMMENTS OF A POST</b></div>
    <div class="row">
      <div class="col-sm-4 text-right">
        <label>Input Post's ID:</label>
      </div>
      <div class="col-sm-4 text-left">
        <input id="id-input" class="form-control" type="text" placeholder="example of post id: 2, 3, ...">
      </div>
      <div>
        <a id="get-list-btn" type="button" class="btn btn-primary" style="color: white;">Get the list of comments</a>
      </div>
    </div>

  </div>

  <div class="div-table">
    <table id="comment-table" class="table table-bordered table-hover table-striped ">
      <thead>
        <tr class="div-head">
          <th>ID</th>
          <th>Post (ID)</th>
          <th>Email</th>
          <th>Name</th>
          <th>Body</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
         </tbody>
    </table>
  </div>


<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gBASE_URL = "https://jsonplaceholder.typicode.com";

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
  $("#get-list-btn").on("click", function(){
    getListButton();
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
  //function for the Get List Button
  function getListButton(){
      
    //get data from web
    var vIdInputElement = $("#id-input").val();
    console.log(vIdInputElement);
    //validate the data
    if (vIdInputElement == ""){
      alert("Please input the post's ID");
      return;
    };
    
    //call API for getting the comments' list
    $.ajax ({
      url: gBASE_URL + "/posts/" + vIdInputElement + "/comments/" ,
      type: "GET",
      success: function(res){
        console.log(Object.entries(res));
        loadDataToTable(res);
      },
      error: function(ajaxContext){
        console.log(ajaxContext);
      },
    });
  }

  //function for loading the data to table
  function loadDataToTable(paramData){

    var vTable = $("#comment-table");

    for (var bI=0; bI < paramData.length; bI++){
      //create a row of the table
      var vNewRow = $("<tr>").appendTo(vTable);
      //create cells of the rows
      $("<td>", {html: paramData[bI].id}).attr("class", "text-center").appendTo(vNewRow);
      $("<td>", {html: paramData[bI].postId}).attr("class", "text-center").appendTo(vNewRow);
      $("<td>", {html: paramData[bI].email}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].name}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].body}).appendTo(vNewRow);

      //create Detail Button in the action column
      var vAction = $("<td>").appendTo(vNewRow);
      var vDetailBtn = $("<button>")
      .html("Detail")
      .attr("class", "btn btn-warning btn-detail")
      .data("id", paramData[bI].id)
      .appendTo(vAction);
      //add click event for the Detail Button  
      vDetailBtn.click(onDetailBtnClick);
    }
  }

  //add event for Detail Button
  function onDetailBtnClick(paramData){
    
    const vCOMMENT_DETAIL = "Task 520 - Comment Detail.html"
    var vId = paramData.currentTarget;
    var vUrlSiteToOpen = vCOMMENT_DETAIL + "?" + "id=" + $(vId).data("id");
    window.location.href = vUrlSiteToOpen;

  }

 
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  



</script>

</body>

</html>
